''
'' VGA display 50xH (single cog) - demo
''
'' Quick Demo By Jeff Ledger
CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

BLACK           = 0
AQUA            = 40
BLUE            = 12
NAVY            = 7
ROYALBLUE       = 88
SKYBLUE         = 111
HOTPINK         = 200
LAWNGREEN       = 100
ORANGE          = 144
YELLOW          = 240
PEACH           = 148
WHITE           = 254
DARKGRAY        = 87
RED             = 128
PALEYELLOW      = 164
PURPLE          = 136
GREEN           = 98
CYAN            = 127
KHAKI           = 180
OLIVE           = 83
CRIMSON         = 135
PINK            = 199
OFFWHITE        = 232
CHOCOLATE       = 148
MISTYROSE       = 168
SALMON          = 212
DARKSLATE       = 23
YELLOWORANGE    = 224


OBJ
     vga: "50xH_ui"
  
VAR
  long  seed
  
PUB selftest | c,xx,yy

  vga.init
 
  vga.str(string(vga#ESC, "S")) 'S=screen scrolling mode           
 

    vga.backcolor(BLACK)
    vga.cls
    
    vga.textcolor(YELLOW)    
    vga.CENTER(string("WELCOME TO OLDBITCOLLECTOR'S VGA DEMO!",13,13))

    vga.backcolor(RED)
    vga.str(string("Thank You Marko Lukat for the great driver! ",13))
    vga.backcolor(BLACK)

    vga.textcolor(LAWNGREEN)
    vga.locate(0,10)
    vga.center(string("Let's redefine the O character!",13))
    waitcnt(clkfreq * 5 + cnt)
      
    vga.redefine(79,0,60,66,66,66,66,60,0) ' Redefine O
    vga.pokechar(28,10,CHOCOLATE,79)
    vga.drawHline(9,11,39,PALEYELLOW,79)
    waitcnt(clkfreq * 5 + cnt)
    vga.redefine(79,60,102,102,102,102,102,60,0) 'Redefine O back.
    
   randomize(cnt)  
   repeat
    scrolldemo
    dotsdemo
    linesdemo
    boxesdemo
    
PUB linesdemo | i, bx, by, bw, bh

  vga.out(0)
  vga.textcolor(rand(cnt))
  vga.str(string($0A, 18, $0B, 32, "RANDOM LINES"))
  repeat i from 0 to 1023
    bx := 20 + rand(60)
    by := 20 + rand(20)
    bw := rand(40)
    bh := rand(40)
    vga.line(bx-bw/2, by-bh/2, bx+bw/2, by+bh/2, rand(cnt)) 

PUB boxesdemo | i, bx, by, bw, bh
  vga.out(0)
  vga.textcolor(rand(cnt))  
  vga.str(string($0A, 18, $0B, 32, "RANDOM BOXES"))
  repeat i from 0 to 127
    bx := 20 + rand(60)
    by := 20 + rand(20)
    bw := rand(40)
    bh := rand(40)
    vga.box(bx-bw/2, by-bh/2, bx+bw/2, by+bh/2, rand(cnt)) 

PRI randomize(val)
  val?
  seed := val

PRI rand(lim)
  seed := 1103515245 * seed + 12345
  return(||(seed // lim))

PUB dotsdemo | xx,yy,c

    vga.out(0)
    repeat vga#bcnt_raw * 5
      vga.plot(||(?xx//(vga#columns*2)), ||(yy?//(vga#rows*2)), c)
      c++
    repeat vga#bcnt_raw * 5
      vga.plot(||(?xx//(vga#columns*2)), ||(yy?//(vga#rows*2)), -1)
    waitcnt(clkfreq + cnt)

PUB scrolldemo | c
  vga.cls
  repeat c from 1 to 300
     vga.textcolor(rand(cnt))
     vga.str(string("THE PARALLAX PROPELLER EIGHT CORE MICROCONTROLLER!"))
     waitcnt(clkfreq /30 + cnt)
            